/*
* Copyright 2003(c) Theo Pavlidis
* See pack4png.h for a detailed notice on the use of the software
*/	
#include "StdAfx.h"	// needed when compiled under MFC
#include "HistAnalArray.h"
// The project must define P4P_DLL_BUILD
#include "pack4png.h"

static int packBasic(
			long hist[],	// input: histogram
			int levels,		// input: usually 256
			int compression,// min_level of histogram crossings, etc
			int step,		// step of color table (non-zero for global color table GIF)
			BOOL answer,	// if we want to know details
			int pxmap[],	// output: array giving new pixel values in terms of old
			double *erp,		// intergal square error pointer
			RECT z[]		// info about zones
			)
{
	CHistAnalArray H;
	int force, color;
	if(compression > COLOR_P4P) {
		color = 1;
		compression = compression%COLOR_P4P;
	}
	else color = 0;
	if(compression > FORCED_P4P) {
		force = 1;
		compression = compression%FORCED_P4P;
	}
	else force = 0;
	if(H.Initialize(hist, levels, compression, answer)==FALSE) return -1;
	if(H.FormZones(force, color) == 0) { // do not apply filter
		for(int i=0; i<levels; i++) pxmap[i] = i;
		if(erp != NULL) *erp = 0;
		return 0;
	};
	if(answer==TRUE) H.ListZones("Final Result");	// for debugging
	int n = H.Assign(pxmap, step, z);
	if(n>0 && erp != NULL) *erp = H.error();
	return n;
}

int pack4png0(
			long hist[],	// input: histogram
			int compression,// min_level of histogram crossings, etc
			int pxmap[]		// output: array giving new pixel values in terms of old
			)
{
	return packBasic(hist, 256, compression, 0, 0, pxmap, NULL, NULL);
}

int pack4png1(
			long hist[],	// input: histogram
			int levels,		// input: usually 256
			int compression,// min_level of histogram crossings, etc
			int pxmap[],	// output: array giving new pixel values in terms of old
			double *erp		// intergal square error pointer
			)
{
	return packBasic(hist, levels, compression, 0, 0, pxmap, erp, NULL);
}

int pack4png2(
			long hist[],	// input: histogram
			int levels,		// input: usually 256
			int compression,// min_level of histogram crossings, etc
			BOOL answer,	// if we want to know details
			int pxmap[],	// output: array giving new pixel values in terms of old
			double *erp,		// intergal square error pointer
			RECT z[]		// info about zones
			)

{
	return packBasic(hist, levels, compression, 0, answer, pxmap, erp, z);
}

int pack4gct0(
			long hist[],	// input: histogram
			int compression,// min_level of histogram crossings, etc
			int pxmap[]		// output: array giving new pixel values in terms of old
			)
{
	return packBasic(hist, 256, compression, 51, 0, pxmap, NULL, NULL);
}

int pack4gct1(
			long hist[],	// input: histogram
			int levels,		// input: usually 256
			int compression,// min_level of histogram crossings, etc
			int pxmap[],	// output: array giving new pixel values in terms of old
			double *erp		// intergal square error pointer
			)
{
	return packBasic(hist, levels, compression, 51, 0, pxmap, erp, NULL);
}

int pack4gct2(
			long hist[],	// input: histogram
			int levels,		// input: usually 256
			int compression,// min_level of histogram crossings, etc
			BOOL answer,	// if we want to know details
			int pxmap[],	// output: array giving new pixel values in terms of old
			double *erp,		// intergal square error pointer
			RECT z[]		// info about zones
			)
{
	return packBasic(hist, levels, compression, 51, answer, pxmap, erp, z);
}


